import 'dart:async';
import 'package:flutter/services.dart';
import 'package:mzanalytics_mybmw/mzanalytics_log.dart';

///Mzanalytics_android
class MzanalyticsAndroid {
  static const MethodChannel _channel =
      const MethodChannel('mzanalytics_mybmw');

  ///initEvent
  static Future<void> initEvent() async {
    try {
      _channel.invokeMethod('initEvent');
    } catch (e, stack) {
      MzanalyticsLog.p(e + stack);
    }
  }

  ///trackEvent
  static Future<void> trackEvent(var parameter) async {
    try {
      _channel.invokeMethod('trackEvent', parameter);
    } catch (e, stack) {
      MzanalyticsLog.p(e + stack);
    }
  }

  ///trackPageView
  static Future<void> trackPageView(var parameter) async {
    try {
      _channel.invokeMethod('trackPageView', parameter);
    } catch (e, stack) {
      MzanalyticsLog.p(e + stack);
    }
  }

  ///trackSiteCustomEvent
  static Future<void> trackSiteCustomEvent(var parameter) async {
    try {
      _channel.invokeMethod('trackSiteCustomEvent', parameter);
    } catch (e, stack) {
      MzanalyticsLog.p(e + stack);
    }
  }

  ///trackPulse
  static Future<void> trackPulse() async {
    try {
      _channel.invokeMethod('trackPulse');
    } catch (e, stack) {
      MzanalyticsLog.p(e + stack);
    }
  }

  ///handleOpenURL
  static Future<void> handleOpenURL(String url) async {
    try {
      _channel.invokeMethod('handleOpenURL', url);
    } catch (e, stack) {
      MzanalyticsLog.p(e + stack);
    }
  }


  ///getCid
  static Future<String> getCid() async {
    try {
      return _channel.invokeMethod('getCid');
    } catch (e, stack) {
      MzanalyticsLog.p(e + stack);
    }
    return "";
  }

  ///setCd
  static Future<void> setCd(var key, var value) async {
    try {
      return _channel.invokeMethod(
          'setCd', <String, dynamic>{'cd_key': key, "cd_value": value});
    } catch (e, stack) {
      MzanalyticsLog.p(e + stack);
    }
  }

  ///setCm
  static Future<void> setCm(var key, var value) async {
    try {
      return _channel.invokeMethod(
          'setCm', <String, dynamic>{'cm_key': key, "cm_value": value});
    } catch (e, stack) {
      MzanalyticsLog.p(e + stack);
    }
  }

  ///deleteCd
  static Future<void> deleteCd(var key) async {
    try {
      return _channel
          .invokeMethod('deleteCd', <String, dynamic>{'cd_key': key});
    } catch (e, stack) {
      MzanalyticsLog.p(e + stack);
    }
  }

  ///deleteCm
  static Future<void> deleteCm(var key) async {
    try {
      return _channel
          .invokeMethod('deleteCm', <String, dynamic>{'cm_key': key});
    } catch (e, stack) {
      MzanalyticsLog.p(e + stack);
    }
  }

  ///getCdAndCm
  static Future<Map> getCdAndCm() async {
    try {
      return _channel.invokeMethod('getCdAndCm');
    } catch (e, stack) {
      MzanalyticsLog.p(e + stack);
    }
    return Map();
  }

  ///isAutoTrackpage
  static Future<bool> isAutoTrackpage() async {
    try {
      return _channel.invokeMethod('isAutoTrackpage');
    } catch (e, stack) {
      MzanalyticsLog.p(e + stack);
    }
    return false;
  }

  ///getManualtrackpage
  static Future<List> getManualtrackpage() async {
    try {
      return _channel.invokeMethod('getManualtrackpage');
    } catch (e, stack) {
      MzanalyticsLog.p(e + stack);
    }
    return [];
  }

  ///setEnableLog
  static Future<void> setEnableLog(bool parameter) async {
    try {
      _channel.invokeMethod('setEnableLog', {'Enable': parameter});
    } catch (e, stack) {
      MzanalyticsLog.p(e + stack);
    }
  }
}
